import { BodyParser, Decoder, Encoder, HttpResponse, MetadataBearer, OperationModel, ResponseParser, StreamCollector, ServiceExceptionParser } from '@aws-js-sdk-v3-prerelease/types';
export declare class RestParser<StreamType> implements ResponseParser<StreamType> {
    private readonly bodyParser;
    private readonly bodyCollector;
    private readonly parseServiceException;
    private readonly utf8Encoder;
    private readonly base64Decoder;
    constructor(bodyParser: BodyParser, bodyCollector: StreamCollector<StreamType>, parseServiceException: ServiceExceptionParser, utf8Encoder: Encoder, base64Decoder: Decoder);
    parse<OutputType extends MetadataBearer>(operation: OperationModel, input: HttpResponse<StreamType>): Promise<OutputType>;
    private parseBody;
    private parseHeaders;
    private parseScalarBody;
    private parseScalarHeader;
    private parseStatusCode;
    private resolveBody;
    private resolveBodyString;
    private responseIsSuccessful;
}
